'*****************************************
'*  HDTV 1920 x 1080p - luma/color bars  *
'*****************************************

' P3 = Y
' P2 = Pb
' P1 = Pr

CON

  _clkmode = xinput
  _xinfreq = 60_000_000

  s = 43	'scales DAC output (s = 0..128)


DAT		org

		reps	#256,#4			'start 8-bit incrementing sequence at $BB
		setspa	#$BB
		incmod	x,#63		wc
	if_c	mov	luma,lumas
		pusha	luma
		add	luma,lumad

		setctra	#%00111			'set ctra for PLL*8
                setfrqa	frqa_			'set frqa

		setvid	#%0110			'set vid for hdtv output
		setvidy	vidy_			'set yiq coefficients
		setvidi	vidi_
		setvidq	vidq_

		cfgdacs	#%11_11_11_00		'set top three dacs to video mode (Y/Pb/Pr)

		cfgpins	pinmask,pindacs		'set pins for dac outputs
'
'
' Field loop
'
field           mov	x,#36			'top blanks
		call	#blank

                mov     y,lines_vis		'set visible lines
line	        call	#sync			'do horizontal sync
		waitvid	v60,sync_color1		'porch
		waitvid	mode,#0			'256*5 clocks per waitvid - show luma/colorbars
		djnz    y,#line           	'another tile line?

                mov     x,#4			'bottom blanks
		call	#blank

		mov	x,#10			'low vertical syncs
vsyncl		call	#sync
		waitvid	v880,sync_color2
		djnz	x,#vsyncl

		mov	x,#10			'high vertical syncs
vsynch		call	#sync
		waitvid	v880,sync_color1
		djnz	x,#vsynch

                jmp     #field                  'field loop


blank		call	#sync			'blank lines
		waitvid	v1980,sync_color1
		djnz	x,#blank
blank_ret	ret

sync		waitvid	v44,sync_color1		'horizontal sync
sync_ret	retd
		waitvid	v44,sync_color2
		waitvid	v44,sync_color3
		waitvid	v88,sync_color1
'
'
' Initialized data
'
luma		long	$03020100
lumas		long	$03020100
lumad		long	$04040404

frqa_		long	$4F33_3333		'148.5 MHz

vidy_		long	 80 << 24 + ((+27*s/128) & $FF) << 16 + ((+92*s/128) & $FF) << 8 + (( +9*s/128) & $FF)
vidi_		long	128 << 24 + ((-15*s/128) & $FF) << 16 + ((-49*s/128) & $FF) << 8 + ((+64*s/128) & $FF)
vidq_		long	128 << 24 + ((+64*s/128) & $FF) << 16 + ((-58*s/128) & $FF) << 8 + (( -6*s/128) & $FF)

pinmask		long	%1110			'pin mask for P3..P1
pindacs		long	%1111_101100000		'pin configuration for video DAC

		'	color base	mode		clocks/pixel	clocks/waitvid
mode		long	$BB << 24 +	$A << 20 +	5 << 13 +	1920

lines_vis	long	1080

sync_color1	long	$1_000000
sync_color2	long	$1_E00000 | ((-105*s/128) & $FF)	'sync- on all three outputs
sync_color3	long	$1_E00000 | ((+105*s/128) & $FF)	'sync+ on all three outputs

v44		long	44
v88		long	88
v880		long	880
v60		long	60
v1920		long	1920
v1980		long	1980

x		long	0
y		long	0
