'*************************************
'*  VGA 640 x 480 - luma/color bars  *
'*************************************

' P4 = VSYNC
' P3 = RED
' P2 = GREEN
' P1 = BLUE
' P0 = HSYNC

CON

  _clkmode = xinput
  _xinfreq = 60_000_000

  s = 44	'scales DAC output (s = 0..128)


DAT		org

		reps	#64,#2			'start 8-bit incrementing sequence at $BB
		setspa	#$BB
		pusha	luma
		add	luma,lumad

		setctra	#%00111			'set ctra for PLL*8
                setfrqa	frqa_			'set frqa

		setvid	#%0100			'set vid for vga output
		setvidy	vidy_			'set yiq coefficients
		setvidi	vidi_
		setvidq	vidq_

		cfgdacs	#%11_11_11_11		'set dacs to video mode

		cfgpins	pinmask,pindacs		'set pins for dac outputs
'
'
' Field loop
'
field           mov	x,#33			'top blanks
		call	#blank

                mov     x,lines_vis		'set visible lines
line	        call	#sync			'do horizontal sync
		waitvid	mode,#0			'256*5 clocks per waitvid - show luma/colorbars
	        djnz    x,#line           	'another line?

                mov     x,#10			'bottom blanks
		call	#blank

		setp	#0			'do vertical sync
		mov	x,#2
		call	#blank
		clrp	#0

                jmp     #field                  'field loop


blank		call	#sync			'blank lines
		waitvid	v640,sync_color0
		djnz	x,#blank
blank_ret	ret

sync						'horizontal sync
sync_ret	retd
		waitvid	v16,sync_color0
		waitvid	v96,sync_color1
		waitvid	v48,sync_color0
'
'
' Initialized data
'
luma		long	$03020100
lumad		long	$04040404

frqa_		long	$1000_0000		'30MHz

vidy_		long	$00_01_00_00 * s	'red gain
vidi_		long	$00_00_01_00 * s	'green gain
vidq_		long	$00_00_00_01 * s	'blue gain

pinmask		long	%1111			'pin mask for P0..P3
pindacs		long	%1111_101100000		'pin configuration for video DAC

		'	color base	mode		clocks/pixel	clocks/waitvid
mode		long	$BB << 24 +	$A << 20 +	3 << 13 +	640

lines_vis	long	480

sync_color0	long	$0_000000
sync_color1	long	$1_000000

v16		long	16
v96		long	96
v48		long	48
v640		long	640

x		long	0
